Subject: [bug#27907] [PATCH] graph: Provide access to the package record in the emit

From: Roel Janssen <[email-masked]>
Date: Fri, 25 Aug 2017 11:00:51 +0200

Ludovic Courtès writes:

> Hi!
>
> [email-masked] (Ludovic Courtès) skribis:
>
>> Roel Janssen <[email-masked]> skribis:
>>
>>> I would like to expand the Cypher back-end and in the long run add a
>>> SPARQL graph back-end to GNU Guix.  For this, I will need to have access
>>> to the package records inside the emit-* functions.
>>>
>>> This patch makes this change by essentially changing the "label"
>>> parameter of the emit-* functions passed as "(node-label head)" into a
>>> "node" parameter, passed as "head".
>>>
>>> The rest of the patch adapts the current emit-* functions to this
>>> change.
>>>
>>> I tested the Graphviz, D3js, and Cypher back-ends, and all seem to work
>>> as before.
>>>
>>> Is it OK to apply this change?
>>
>> Sure, looks good to me!
>
> Actually no!  :-)
>
> The problem was that it broke all non-package-related “node types” (like
> “guix graph -t references”), and it had the problem that it ignores the
> ‘label’ procedure in <node-type>.  And “make check” failed.
>
> So I reverted it in 5e60bef9802e448924f889d34d95a249b008652c.  We need
> to rethink about it.
>
> Cheers,
> Ludo’.

Oops!  I am sorry about this.  Would it not break if we include a check for whether
the node type is a package or not.  Then, non-package node types are
handled the “old way” and packages are handled the “new way”.

I think we cannot have a generic way of exposing the specifics of a node
type, so if we need to expose more information for the other node types,
we have to add a type-specific implementation.

If this sounds like a good idea I'll write a new patch.  And while I'm
at it, what set of commands fully cover the graph code for all node
types?  Just all variants in 'guix graph --type=X'?

Thanks!

Kind regards,
Roel Janssen